import React, { useState, useEffect } from 'react';
import { csv } from 'd3';

const csvUrl = 'https://gist.githubusercontent.com/mandadi1999/433e0ded38cf6b19bdfd0e5016e2da7c/raw/f9e281fcff3163555e0ce1b6ea59f7fe762a7a0b/pm2.5.csv';

export const useData = () => {
	const [data, setData] = useState(null);
  
  useEffect(() => {
    let max = 0;
    let min = 20;
    
    const row = d => {
      for (const property in d) {
      	if (property === "id")
          continue;
        if (+d[property] > max) {
        	max = +d[property];
        }
        if (+d[property] < min) {
        	min = +d[property];
        }
      }
    	return d;
    }
  	csv(csvUrl, row).then((res) => {
      res.max = max;
      res.min = min;
      setData(res);
    });
  }, []);
  
  return data;
}